<script setup lang="ts">
import { computed, onMounted, type PropType } from "vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import MarkdownRenderer from "@/components/MarkdownRenderer.vue";
import type { ParameterCombinationDependencies } from "@/types/WorkflowParameters.ts";
import { Tooltip } from "bootstrap";

const props = defineProps({
  parameter: {
    type: Object,
    required: true,
  },
  required: Boolean,
  parameterName: {
    type: String,
    required: true,
  },
  clowmResource: {
    type: Boolean,
    default: false,
  },
  dependencies: {
    type: Array as PropType<string[]>,
    required: false,
  },
  anyOfDependencies: Object as PropType<ParameterCombinationDependencies>,
  oneOfDependencies: Object as PropType<ParameterCombinationDependencies>,
});

const randomIDSuffix = Math.random().toString(16).substring(2, 8);

const helpText = computed<string | undefined>(
  () => props.parameter["help_text"],
);
const parameterType = computed<string>(() => props.parameter["type"] ?? "");
const icon = computed<string | undefined>(() => props.parameter["fa_icon"]);
const description = computed<string>(() => props.parameter["description"]);
const defaultValue = computed<string | undefined>(() =>
  props.parameter["default"]?.toString(),
);
const enumValues = computed<string[] | undefined>(() =>
  props.parameter["enum"]?.map((val: string) => val.toString()),
);
const parameterPattern = computed<string | undefined>(
  () => props.parameter["pattern"],
);

const showRightColum = computed<boolean>(
  () =>
    helpText.value != undefined ||
    props.required ||
    defaultValue.value != undefined,
);

const anyOfTooltip = computed<string | undefined>(() => {
  if (props.anyOfDependencies != undefined) {
    let labelText = `Set one or multiple of the following parameters:<ul class="text-start mb-0"><li>--${props.parameterName}`;
    if (props.anyOfDependencies.group.length > 0) {
      labelText +=
        ", " + props.anyOfDependencies.group.map((a) => "--" + a).join(",");
    }
    labelText += "</li>";
    labelText +=
      props.anyOfDependencies.dependencies
        .map((a) => "<li>" + a.map((b) => "--" + b).join(",") + "</li>")
        .join("") + "</ul>";
    return labelText;
  }
  return undefined;
});

const oneOfTooltip = computed<string | undefined>(() => {
  if (props.oneOfDependencies != undefined) {
    let labelText = `Set exactly one of the following parameters:<ul class="text-start mb-0"><li>--${props.parameterName}`;
    if (props.oneOfDependencies.group.length > 0) {
      labelText +=
        ", " + props.oneOfDependencies.group.map((a) => "--" + a).join(",");
    }
    labelText += "</li>";
    labelText +=
      props.oneOfDependencies.dependencies
        .map((a) => "<li>" + a.map((b) => "--" + b).join(",") + "</li>")
        .join("") + "</ul>";
    return labelText;
  }
  return undefined;
});

// object with parameter name as key and tooltip string for dependentRequired label as value
const dependentTooltip = computed<string | undefined>(() => {
  if (props.dependencies != undefined) {
    return (
      "Required when the following parameters are set: <ul class='ps-4 mb-0 text-start'>" +
      props.dependencies.map((a) => "<li>--" + a + "</li>").join("") +
      "</ul></li>"
    );
  }
  return undefined;
});
onMounted(() => {
  document
    ?.querySelector(`#parameter-${randomIDSuffix}`)
    ?.querySelectorAll("[data-bs-toggle=tooltip]")
    .forEach((tooltipTriggerEl) => {
      Tooltip.getOrCreateInstance(tooltipTriggerEl);
    });
});
</script>

<template>
  <div :id="`parameter-${randomIDSuffix}`" class="border-top">
    <div class="d-flex pt-2 justify-content-between">
      <div class="flex-fill ps-2">
        <div class="row">
          <span class="fs-6 w-fit">
            <font-awesome-icon v-if="icon" :icon="icon" class="me-2" />
            <code :id="props.parameterName" class="border rounded p-1"
              >--{{ props.parameterName }}</code
            >
          </span>
          <span
            v-if="anyOfTooltip != undefined"
            class="rounded py-0 px-1 bg-info ms-2 label w-fit fs-6"
            data-bs-toggle="tooltip"
            data-bs-placement="bottom"
            :data-bs-title="anyOfTooltip"
            data-bs-custom-class="parameter-form-tooltip"
            data-bs-html="true"
            >anyOf</span
          >
          <span
            v-if="oneOfTooltip != undefined"
            class="rounded py-0 px-1 bg-info ms-2 label w-fit fs-6"
            data-bs-toggle="tooltip"
            data-bs-placement="bottom"
            :data-bs-title="oneOfTooltip"
            data-bs-custom-class="parameter-form-tooltip"
            data-bs-html="true"
            >oneOf</span
          >
          <span
            v-if="dependentTooltip != undefined"
            class="rounded py-0 px-1 bg-info ms-2 label w-fit fs-6"
            data-bs-toggle="tooltip"
            data-bs-placement="bottom"
            :data-bs-title="dependentTooltip"
            data-bs-custom-class="parameter-form-tooltip"
            data-bs-html="true"
            >dependency</span
          >
        </div>
        <div class="row align-items-start mt-2">
          <div class="col-auto">
            <template v-if="parameterType">
              <span>type: '{{ parameterType }}'</span>
              <br />
            </template>
            <span v-if="clowmResource"
              ><font-awesome-icon
                icon="fa-solid fa-database"
                class="me-2"
              />CloWM Resource</span
            >
          </div>
          <div class="col-9">
            <markdown-renderer :markdown="description" />
          </div>
        </div>
        <div v-if="enumValues || defaultValue" class="row">
          <div v-if="enumValues" class="dropdown w-fit mb-2">
            <button
              class="rounded-1 dropdown-toggle text-reset text-decoration-none border"
              type="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
            >
              Options:
              <span v-if="defaultValue"
                ><code>{{ defaultValue }}</code> (default)</span
              >
            </button>
            <ul v-if="enumValues" class="dropdown-menu shadow">
              <li v-for="val in enumValues" :key="val" class="px-2">
                {{ val }} <span v-if="val === defaultValue">(default)</span>
              </li>
            </ul>
          </div>
          <span v-else-if="defaultValue" class="rounded-1"
            >default: <code>{{ defaultValue }}</code></span
          >
        </div>
      </div>
      <div
        v-if="showRightColum"
        class="col-auto d-flex flex-column align-items-end flex-fill"
      >
        <button
          v-if="helpText"
          class="btn btn-info btn-sm my-1"
          type="button"
          data-bs-toggle="collapse"
          :data-bs-target="'#helpCollapse' + randomIDSuffix"
          aria-expanded="false"
          :aria-controls="'helpCollapse' + randomIDSuffix"
        >
          <font-awesome-icon icon="fa-solid fa-circle-info" />
          Help
        </button>

        <span
          v-if="props.required"
          class="bg-warning rounded-1 px-1 py-0 text-white"
          >required</span
        >
      </div>
    </div>
    <div v-if="helpText" :id="'helpCollapse' + randomIDSuffix" class="collapse">
      <div class="p-2 pb-0 border rounded m-2 flex-shrink-1">
        <markdown-renderer class="helpTextCode" :markdown="helpText" />
        <span v-if="parameterPattern" class="mb-2"
          >Pattern: <code>{{ parameterPattern }}</code></span
        >
      </div>
    </div>
  </div>
</template>

<style scoped>
code {
  color: var(--bs-code-color) !important;
}

li:hover {
  background: var(--bs-secondary);
}

a:hover {
  filter: brightness(1.2);
}

code.border {
  backdrop-filter: brightness(0.95);
}

.label {
  cursor: help;
}
</style>
